<template>
  <v-layout column justify-center align-center>
    <v-card-text>

      <form>
        <label>
          <input style="display:none;" type="file" ref="fileInput" @change="onFileChange">
          <v-icon large style="cursor: pointer">file_copy</v-icon>
        </label>
      </form>
    </v-card-text>

    <div class="text-xs-center pt-2">
      <v-btn color="primary" @click.native="uploadToDB">upload</v-btn>
    </div>
    <v-data-table :headers="headers" :items="$store.state.excelData" :search="search" v-model="selected" item-key="name"
      select-all class="elevation-1">
      <template slot="headerCell" slot-scope="props">
        <v-tooltip bottom>
          <span slot="activator">
            {{ props.header.text }}
          </span>
          <span>
            {{ props.header.text }}
          </span>
        </v-tooltip>
      </template>
      <template slot="headers" slot-scope="props">
        <tr>
          <th>
            <v-checkbox :input-value="props.all" :indeterminate="props.indeterminate" primary hide-details
              @click.native="toggleAll"></v-checkbox>
          </th>
          <th v-for="header in props.headers" :key="header.text" :class="['column sortable', pagination.descending ? 'desc' : 'asc', header.value === pagination.sortBy ? 'active' : '']"
            @click="changeSort(header.value)">
            <v-icon small>arrow_upward</v-icon>
            {{ header.text }}
          </th>
        </tr>
      </template>

      <template slot="items" slot-scope="props">
        <td>
          <v-checkbox v-model="props.selected" primary hide-details></v-checkbox>
        </td>
        <td>{{ props.item.source }}</td>
        <td class="text-xs-right">{{ props.item.orderDate }}</td>
        <td class="text-xs-right">{{ props.item.location }}</td>
        <td class="text-xs-right">{{ props.item.type }}</td>
        <td class="text-xs-right">{{ props.item.lampNo }}</td>
        <td class="text-xs-right">{{ props.item.repairStaff }}</td>
        <td class="text-xs-right">{{ props.item.callOut }}</td>
        <td class="text-xs-right">{{ props.item.district }}</td>

      </template>
    </v-data-table>

  </v-layout>

</template>

<script>
  import XLSX from 'xlsx';
  import moment from 'moment';
  import axios from 'axios';
  import _ from 'lodash';

  export default {
    data() {
      return {
        search: '',
        pagination: {
          sortBy: 'lampNo'
        },
        selected: [],
        headers: [
          // {
          //   text: '來源',
          //   align: 'left',
          //   sortable: false,
          //   value: 'source'
          // },
          // {
          //   text: '出 Order 日期',
          //   value: 'orderDate'
          // },
          // {
          //   text: 'Location',
          //   value: 'location'
          // },
          // {
          //   text: '路燈(N), 村燈(Y), 左行燈, 路牌燈, 飛天線, 拆天線, 其他',
          //   value: 'type'
          // },
          {
            text: '燈號',
            value: 'lampNo'
          },
          // {
          //   text: '維修同事',
          //   value: 'repairStaff'
          // },
          // {
          //   text: 'Call Out',
          //   value: 'callOut'
          // },
          // {
          //   text: 'District',
          //   value: 'district'
          // }
        ]
      }
    },
    created() {
      this.initialize()
    },
    methods: {
      initialize() {
       this.$store.dispatch('init');
      },
      toggleAll() {
        if (this.selected.length) this.selected = []
        else this.selected = this.$store.state.excelData.slice()
      },
      changeSort(column) {
        if (this.pagination.sortBy === column) {
          this.pagination.descending = !this.pagination.descending
        } else {
          this.pagination.sortBy = column
          this.pagination.descending = false
        }
      },
      async uploadToDB() {
        await this.$store.dispatch('setRepairment');

        const url = 'http://192.168.10.231:5000/http://192.168.10.231:46080/repairment/insert';
        const district = this.$store.state.auth.username;
        const repair = this.$store.state.repairment;
        let uploaded = false;

        for (let i = 0; i < this.selected.length; i++) {
          //   for (let y = 0; y < repair.length; y++) {
          //     if (repair[y].lampNo == this.selected[i].lampNo) {
          //       uploaded = true;
          //       break;
          //     }
          //   }
          //   if (!uploaded) {
          const data = Object.assign({}, this.selected[i]);
          data.district = district;
          delete data['value'];
          delete data['name'];
          const opt = {
            method: 'POST',
            headers: {
              'content-type': 'application/json',
              'X-Requested-With': 'XMLHttpRequest'
            },
            data: data,
            url,
          }
          const response = await axios(opt);
          if (response.data == 'no detail has been found') {
            alert('"' + this.selected[i].lampNo + '" cannot be found');
          } else {
            let deleteItems = [];
            for (let i in this.selected) {
              deleteItems.push(this.selected[i].name);
            }
            this.$store.dispatch('deleteExcelData', deleteItems); //delete excelData
          }
          

          //   } else {
          //       alert(this.selected[i].lampNo + '已被上載');
          //   }
        }
        alert('Finished');

      },
      fixdata(data) {
        var o = "",
          l = 0,
          w = 10240;
        for (; l < data.byteLength / w; ++l) o += String.fromCharCode.apply(null, new Uint8Array(data.slice(l * w, l *
          w + w)));
        o += String.fromCharCode.apply(null, new Uint8Array(data.slice(l * w)));
        return o;
      },
      get_excelData(sheet) {

        let data = [],
          range = XLSX.utils.decode_range(sheet['!ref']);
          console.log('range: ');
          console.log(range.s)
          console.log(range.e)
        let C = range.s.c;
        let R = range.s.r; /* start in the first row */
        let encoded, cell, cellValue;
        let lampRecord = {
          value: false, //for selection use
          name: null, //for selection use
          lampNo: '',
          deleted: false,
          repaired: false
        }
        let lampRecordKeys = Object.keys(lampRecord);
        let hdr;
        console.log('this.$store.state.auth.username: ' + this.$store.state.auth.username);
        // if (this.$store.state.auth.username == 'ntw') {
        //   for (R = range.s.r; R <= range.e.r; R++) {
        //     encoded = XLSX.utils.encode_cell({
        //       c: C,
        //       r: R
        //     });
        //     console.log('encoded: ');
        //     console.log(encoded);
        //     cell = sheet[encoded];
        //     console.log(cell);
        //     if (cell && cell.v && cell.t == 's' && cell.v.includes('公司巡燈')) {
        //       R++;
        //       encoded = XLSX.utils.encode_cell({
        //         c: C,
        //         r: R
        //       });
        //       cell = sheet[encoded];
        //       console.log('cell: ');
        //       console.log(cell);
        //       while (!cell || cell.t == 'n' && R <= range.e.r) {
        //         console.log('inside')
        //         let item = Object.assign({}, lampRecord);
        //         console.log('item')
        //         console.log(item)
        //         while (!cell && R <= range.e.r) {
        //           console.log('not a cell')
        //           R++;
        //           encoded = XLSX.utils.encode_cell({
        //             c: C,
        //             r: R
        //           });
        //           cell = sheet[encoded];
        //         }
        //         if ( R > range.e.r || cell.t == 's') {
        //           break;
        //         }
        //         item.name = R;

        //         encoded = XLSX.utils.encode_cell({
        //           c: 6,
        //           r: R
        //         });
        //         cell = sheet[encoded];
        //         item.lampNo = cell.w;
        //         data.push(item);
        //         R++;
        //         C = 0;
        //         encoded = XLSX.utils.encode_cell({
        //           c: C,
        //           r: R
        //         });
        //         cell = sheet[encoded];
        //         console.log('item')
        //         console.log(item)
        //       }
        //       break;
        //     }
        //     hdr = XLSX.utils.format_cell(cell);

        //   };
        // } else if (this.$store.state.auth.username == 'hki') {
          for (R = range.s.r; R <= range.e.r; R++) {
            encoded = XLSX.utils.encode_cell({
              c: C,
              r: R
            });
            cell = sheet[encoded];

            let item = Object.assign({}, lampRecord);
            item.lampNo = cell.w;
            data.push(item);
          }
          hdr = XLSX.utils.format_cell(cell);
        // }

        return data;
      },
      onFileChange($event) {
        $event.stopPropagation();
        $event.preventDefault();
        const files = $event.target.files || $event.dataTransfer.files;

        let i, f;
        for (i = 0, f = files[i]; i != files.length; ++i) {
          var reader = new FileReader(),
            name = f.name;
          const parent = this;
          reader.onload = function (e) {
            var results,
              data = e.target.result,
              fixedData = parent.fixdata(data),
              workbook = XLSX.read(btoa(fixedData), {
                type: 'base64'
              }),
              firstSheetName = workbook.SheetNames[0],
              worksheet = workbook.Sheets[firstSheetName];
            if (!worksheet['!ref']) {
              alert("Nothing on the excel file");
            } else {
              const excelData = parent.get_excelData(worksheet);
              parent.$store.dispatch('setExcelData', excelData);
              results = XLSX.utils.sheet_to_json(worksheet);
              parent.$store.state.tickets = results;
            }

          };
          reader.readAsArrayBuffer(f);
        }

      }
    }
  }

</script>
